<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\Session\Session;
use Zeedhi\Framework\DTO\Response\Message;
use \Setforms2\Shared\ORM\DateTime;

use Teknisa\MAN\Utilities\Util;

class CampanhaCompreEGanheController extends \Teknisa\MAN\Controllers\TeknisaCrud {
    
    protected $dataSourceManager;
    protected $utilService;
    protected $crudService;
    protected $parameterBag;
    
    public function __construct($crudService, $parameterBag, $paramBag, $dataSourceManager, Util $utilService) {
        $this->crudService          = $crudService;
        $this->parameterBag         = $parameterBag;
        $this->dataSourceManager    = $dataSourceManager;
		$this->utilService          = $utilService;
    }
        
    const dataSourceVigencia      = 'vnd17000_campanhaCompreGanhe';
    const dataSourceCampanha      = 'vnd17000_adicionarCampanhaCompreGanhe';
    
    public function find(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = self::dataSourceVigencia;
        $this->parameterBagColumns = array('NRORG');
        parent::find($request,$response);
    }    
    
    public function save(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName    = self::dataSourceVigencia;
        $rows = $request->getDataSet()->getRows();
         
        parent::save($request, $response);
        
        if(!$rows[0]['__is_new']) {
            $this->dataSourceName = self::dataSourceCampanha;
            parent::save($request, $response);
        }
        
    }
    
    public function delete(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName    = self::dataSourceVigencia;
        parent::delete($request, $response);
    }
    
    public function deleteCampanha(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = self::dataSourceCampanha;
        parent::delete($request, $response);
    }
}