<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Teknisa\MAN\Factories;

use Teknisa\Libs\Util\Environment;

class ConsolidacaoAutomatica {

	protected $entityManager;
	protected $util;
	protected $consolidacaoAutFactory;
	protected $environment;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Utilities\Util $util, 
	Factories\ConsolidacaoAutomatica $consolidacaoAutFactory, Environment $environment)  {
		$this->entityManager 	= $entityManager;
		$this->util             = $util;
		$this->consolidacaoAutFactory  = $consolidacaoAutFactory;
		$this->environment = $environment;
	}
	
	public function buscaConsolidacoes($params) {
        $CDFILIAL = $params[0]['value'];
		$CDLOJA   = $params[1]['value'];
		$NRORG    = $params[2]['value'];
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDLOJA' 	=> $CDLOJA,
			':NRORG'    => $NRORG
		);
		$result = $this->consolidacaoAutFactory->buscaConsolidacoes($params);
		
		return $result;
	}
	
	public function insertConsolidacoes ($params) {
        $CDFILIAL         = $params[0]['CDFILIAL'];
        $CDLOJA           = $params[0]['CDLOJA'];
		$DTINICONSVENAUT  = $params[0]['DTINICONSVENAUT'];
		$IDFREQCONSVEN    = $params[0]['IDFREQCONSVEN'];
		$HRCONSVENAUT     = str_replace(':', '', $params[0]['HRCONSVENAUT']);
        $DSDIRARQPHP	  = $params[0]['DSDIRARQPHP'];
        $DSDIRINSTALAPHP  = $params[0]['DSDIRINSTALAPHP'];
        $DSSTATUSULTCONS  = $params[0]['DSSTATUSULTCONS'];
        $NRORG            = $params[0]['NRORG'];
		$params = array(
			':CDFILIAL' 	   => $CDFILIAL,
			':CDLOJA' 		   => $CDLOJA,
			':DTINICONSVENAUT' => $DTINICONSVENAUT,
			':IDFREQCONSVEN'   => $IDFREQCONSVEN,
			':HRCONSVENAUT'    => $HRCONSVENAUT,
			':DSDIRARQPHP'     => $DSDIRARQPHP,
			':DSDIRINSTALAPHP' => $DSDIRINSTALAPHP,
			':DSSTATUSULTCONS' => $DSSTATUSULTCONS,
			':NRORG'           => $NRORG,
		);
		$standarts = $this->consolidacaoAutFactory->insertConsolidacoes($params);
		return $standarts;
	}
	
	public function updateConsolidacoes ($params) {
		$CDFILIAL         = $params[0]['CDFILIAL'];
        $CDLOJA           = $params[0]['CDLOJA'];
        $DTINICONSVENAUT  = $params[0]['DTINICONSVENAUT'];
        $IDFREQCONSVEN    = $params[0]['IDFREQCONSVEN'];
		$HRCONSVENAUT     = str_replace(':', '', $params[0]['HRCONSVENAUT']);
        $DSDIRARQPHP	  = $params[0]['DSDIRARQPHP'];
        $DSDIRINSTALAPHP  = $params[0]['DSDIRINSTALAPHP'];
        $DSSTATUSULTCONS  = $params[0]['DSSTATUSULTCONS'];

		$params = array(
			':CDFILIAL' 	   => $CDFILIAL,
			':CDLOJA' 		   => $CDLOJA,
			':DTINICONSVENAUT' => $DTINICONSVENAUT,
			':IDFREQCONSVEN'   => $IDFREQCONSVEN,
			':HRCONSVENAUT'    => $HRCONSVENAUT,
			':DSDIRARQPHP'     => $DSDIRARQPHP,
			':DSDIRINSTALAPHP' => $DSDIRINSTALAPHP,
			':DSSTATUSULTCONS' => $DSSTATUSULTCONS
		);
		$standarts = $this->consolidacaoAutFactory->updateConsolidacoes($params);
		return $standarts;
	}
	
	public function removeConsolidacoes ($params) {
        $CDFILIAL         = $params[0]['CDFILIAL'];
        $CDLOJA           = $params[0]['CDLOJA'];
		$DTINICONSVENAUT  = $params[0]['DTINICONSVENAUT'];
		$IDFREQCONSVEN    = $params[0]['IDFREQCONSVEN'];
		$HRCONSVENAUT     = $params[0]['HRCONSVENAUT'];
        $DSDIRARQPHP	  = $params[0]['DSDIRARQPHP'];
        $DSDIRINSTALAPHP  = $params[0]['DSDIRINSTALAPHP'];
        $DSSTATUSULTCONS  = $params[0]['DSSTATUSULTCONS'];
		
		$params = array(
			':CDFILIAL' 	   => $CDFILIAL,
			':CDLOJA' 		   => $CDLOJA,
			':DTINICONSVENAUT' => $DTINICONSVENAUT,
			':IDFREQCONSVEN'   => $IDFREQCONSVEN,
			':HRCONSVENAUT'    => $HRCONSVENAUT,
			':DSDIRARQPHP'     => $DSDIRARQPHP,
			':DSDIRINSTALAPHP' => $DSDIRINSTALAPHP,
			':DSSTATUSULTCONS' => $DSSTATUSULTCONS
		);
		$standarts = $this->consolidacaoAutFactory->removeConsolidacoes($params);
		return $standarts;
	}

	public function buscaProdutos($params) {
		$produtos = $this->consolidacaoAutFactory->buscaProdutos($params);
		
		return $produtos;
	}
	
	public function buscaTipoRetiradaFilial($params) {
		$cdtiporeti = $this->consolidacaoAutFactory->buscaTipoRetiradaFilial($params);
		
		return $cdtiporeti;
	}
}