<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
//use Teknisa\Libs\Util\NewCode;
use Teknisa\MAN\Utilities;
use \Zeedhi\Framework\Util\Functions;

class RelDREService {
    
    // protected $birtStrategy;

	public function __construct(EntityManager $entityManager/*, newCode $newCode/*, birtStrategy $birtStrategy*/) {
        $this->entityManager = $entityManager;
        //$this->newCode = $newCode;
        //$this->birtStrategy        = $birtStrategy;
    }
    
    /********************
     *  PARAM METHODS   *
     ********************/
    
    public function verifyClassFina($conditions){
        //Verifica se já existe alguma class. financeira salva com o mesmo valor de ordem enviado pelo frontend
        $params = array(
            'IDORDEMDRE'    => $conditions['IDORDEMDRE'],
            'CDCLASSFINA'   => $conditions['CDCLASSFINA'],
            'NRORG'         => $conditions['NRORG']
        );
        $verificacao = $this->entityManager->getConnection()->fetchAll(self::VERIFY_ORDEM, $params);
        if(sizeof($verificacao) == 0){
            return array(true);
        } elseif($verificacao[0]['CDCLASSFINA'] == $conditions['CDCLASSFINA']){
            return array(true);
        } else {
            return array(
                false,
                $verificacao[0]['DSCLASSFINA'],
                $verificacao[0]['IDORDEMDRE']
            );
        }
    }
    
    public function saveClassFina($conditions){
        try{
            $params = array(
                'CDCLASSFINA'   => $conditions['CDCLASSFINA'],
                'NRORG'         => $conditions['NRORG'],
                'IDTPCLASS'     => $conditions['IDTPCLASS'],
                'IDVISUDRE'     => $conditions['IDVISUDRE'],
                'IDORDEMDRE'    => $conditions['IDORDEMDRE']
            );
            return $this->entityManager->getConnection()->executeQuery(self::UPDATE_CLASS_TYPE, $params);
        } catch(Exception $e){
            throw $e;
        }
    }
    
    public function saveGeralTab($conditions){
        try{
            $params = array(
                ':NRORG' => $conditions['NRORG']
            );
            $verificacao = $this->entityManager->getConnection()->fetchAll(self::VERIFY_PARAM_GERAL, $params);
            unset($params);
            
            /**
             * PARÂMETRO CDAJUCTPAGDRE DEVE SER ALTERADO POSTERIORMENTE NO BANCO POR CDAJUCTRECDRE
             */ 
            $params = array(
                'CDTIPORETIVENDA'  => Functions::arrayKeyExists('CDTIPORETIVENDA'  ,  $conditions) ? $conditions['CDTIPORETIVENDA']  : NULL,
                'CDTIPORETIFUNC'   => Functions::arrayKeyExists('CDTIPORETIFUNC'   ,  $conditions) ? $conditions['CDTIPORETIFUNC']   : NULL,
                'CDTIPORETIDESP'   => Functions::arrayKeyExists('CDTIPORETIDESP'   ,  $conditions) ? $conditions['CDTIPORETIDESP']   : NULL,
                'CLASSFINCOMPRA'   => Functions::arrayKeyExists('CLASSFINCOMPRA'   ,  $conditions) ? $conditions['CLASSFINCOMPRA']   : NULL,
                'CLASSFINDESPESAS' => Functions::arrayKeyExists('CLASSFINDESPESAS' ,  $conditions) ? $conditions['CLASSFINDESPESAS'] : NULL,
                'CDCLASSFINADRE'   => Functions::arrayKeyExists('CDCLASSFINADRE'   ,  $conditions) ? $conditions['CDCLASSFINADRE']   : NULL,
                'CDAJUCTRECDRE'    => Functions::arrayKeyExists('CDAJUCTRECDRE'    ,  $conditions) ? $conditions['CDAJUCTRECDRE']    : NULL,
                'CDAJUDESPESAS'    => Functions::arrayKeyExists('CDAJUDESPESAS'    ,  $conditions) ? $conditions['CDAJUDESPESAS']    : NULL,
                'NRORG'            => $conditions['NRORG']
            );
            if($verificacao[0]['REGISTROS'] > 0){
                return $this->entityManager->getConnection()->executeQuery(self::UPDATE_PARAM_GERAL, $params);
            } else {
                return $this->entityManager->getConnection()->executeQuery(self::INSERT_PARAM_GERAL, $params);
            }
        } catch(Exception $e){
            throw $e;
        }
    }
    
    
    /********************
     *  REPORT METHODS  *
     ********************/
     
    public function verifyReportType($conditions){
       /* if($conditions['TIPORELATORIO'] == 'MC'){
            $params = self::DRE_MensalParamBuild($conditions);
        }
        if($conditions['TIPORELATORIO'] == 'MA'){
            $params = self::DRE_MensalParamBuild($conditions);
        }*/
         $params = self::DRE_MensalParamBuild($conditions);
        return $params;
    }
    
    private function DRE_MensalParamBuild($conditions){
        //$custoProd  = self::somaCustoProd($conditions, $dateParams);
        $dateParams = self::buildDateParams($conditions);
        //$nrSeqMovi = $this->newCode->getCodeByTableName('MOVIESTOQUE', $conditions['NRORG']);
        // $format = $this->birtStrategy->setReportFormat($row["FORMAT"]);
        /*  $params = array (
                ':CDFILIAL' => $conditions['CDFILIAL']
            );
            $cdEmpresa  = $this->entityManager->getConnection()->fetchAll(self::GET_EMPRESA, $params);
        */
        unset($params);
        $conditions = $this->buildParams('CDFILIAL',$conditions);
        $params = array (
            'CDFILIAL'      => $conditions['CDFILIAL'],
            'MESATUAL'      => $dateParams['MESATUAL'],
            'DTFINMES'      => $dateParams['DTFINMES'],
            'DTINI'         => $dateParams['DTINI'],
            'DTATUAL'       => $dateParams['DTINI'],
            'DTFIN'         => $dateParams['DTFIN'],
            'DTINIULTMES'   => $dateParams['DTINIULTMES'],
            'DTFINULTMES'   => $dateParams['DTFINULTMES'],
            'DTINIULTANO'   => $dateParams['DTINIULTANO'],
            'DTFINULTANO'   => $dateParams['DTFINULTANO'],
            'REGIME'        => $conditions['REGIME'],
            'NRORG'         => $conditions['NRORG'],
            'CDOPERADOR'    => $conditions['CDOPERADOR']
            //'CDEMPRESA'     => $cdEmpresa[0]['CDEMPRESA'],
            //'SEQMOVI'       => $nrSeqMovi
        );
        if($conditions['TIPORELATORIO'] == 'MA'){
            $reportName = 'DREAnali';
        } else if($conditions['TIPORELATORIO'] == 'MC'){
            $reportName = 'DRE';
        } else if($conditions['TIPORELATORIO'] == 'MG'){
            $reportName = 'DREGeral';
        }
        $params = array(
            'ParametersRow' => $params,
            'ReportName'    => $reportName
        );
        return $params;
    }
    
    private function buildDateParams($conditions){
        $thisDate = array(
            'MES' => explode('/', $conditions['DATAINI'])[0],
            'ANO' => explode('/', $conditions['DATAINI'])[1]
        );
        
        $diaPrimeiroAtual = '01'.'/'.$thisDate['MES'].'/'.$thisDate['ANO'];
        $dataAtual = date('d/m/Y', time());
        $mesAtual = 'N';
        if(explode('/', $dataAtual)[1] == $thisDate['MES']){
            //Se o mês de competência escolhido for o atual, a data final deve ser a última data de competência deste mês, ou seja, a data atual
            $ultimoDiaAtual = explode('/', $dataAtual)[0].'/'.$thisDate['MES'].'/'.$thisDate['ANO'];
            if(explode('/', $dataAtual)[0] !== '01' && explode('/', $dataAtual)[0] !== '1') {
                $penultimoDiaAtual = intval(explode('/', $dataAtual)[0]) - 1 .'/'.$thisDate['MES'].'/'.$thisDate['ANO'];
            } else {
                $penultimoDiaAtual = $ultimoDiaAtual;
            }
            $mesAtual = 'S';
        } else {
            //Se o mês de competência escolhido não for o atual, a data final deve ser o último dia possível para o determinado mês escolhido
            $ultimoDiaAtual = date('t', strtotime(str_replace("/", "-", $diaPrimeiroAtual))).'/'.$thisDate['MES'].'/'.$thisDate['ANO'];
            $penultimoDiaAtual = date('t', strtotime(str_replace("/", "-", $diaPrimeiroAtual))).'/'.$thisDate['MES'].'/'.$thisDate['ANO'];
        }
        //Se o mês enviado pelo frontend é janeiro, se for o mês anterior deve ser dezembro do ano anterior
        if($thisDate['MES'] !== '01'){
            $diaPrimeiroUltMes = '01'.'/'.((intval($thisDate['MES']) -1 <=9)?'0':'').(intval($thisDate['MES']) -1 ).'/'.$thisDate['ANO'];
            $ultimoDiaUltMes = date('t', strtotime(str_replace("/", "-", $diaPrimeiroUltMes))).'/'.((intval($thisDate['MES']) -1 <=9)?'0':'').(intval($thisDate['MES']) -1 ).'/'.$thisDate['ANO'];
        } else {
            $diaPrimeiroUltMes = '01'.'/'.'12'.'/'.(intval($thisDate['ANO']) - 1);
            $ultimoDiaUltMes = '31/12'.'/'.(intval($thisDate['ANO']) - 1);
        }
        $diaPrimeiroUltAno = '01'.'/'.$thisDate['MES'].'/'.(intval($thisDate['ANO']) - 1);
        $ultimoDiaUltAno = date('t', strtotime(str_replace("/", "-", $diaPrimeiroUltAno))).'/'.$thisDate['MES'].'/'.(intval($thisDate['ANO']) - 1);
        $dateParams = array(
            'DTINI'       => $diaPrimeiroAtual,
            'DTFIN'       => $ultimoDiaAtual,
            'DTFINMES'    => $penultimoDiaAtual,
            'DTINIULTMES' => $diaPrimeiroUltMes,
            'DTFINULTMES' => $ultimoDiaUltMes,
            'DTINIULTANO' => $diaPrimeiroUltAno,
            'DTFINULTANO' => $ultimoDiaUltAno,
            'MESATUAL'    => $mesAtual
        );
        return $dateParams;
    }
    
    private function buildParams ($key, $conditions){
        $conditions[$key] = implode('_', $conditions[$key]);
        return $conditions;
     }
    
    const UPDATE_CLASS_TYPE = "
		UPDATE CLASSFINANC
          SET IDTPCLASS  = :IDTPCLASS,
              IDVISUDRE  = :IDVISUDRE,
              IDORDEMDRE = :IDORDEMDRE
        WHERE  NRORG = :NRORG
          AND CDCLASSFINA = :CDCLASSFINA
	";
    
    const GET_EMPRESA = "
        SELECT CDEMPRESA FROM FILIAL WHERE CDFILIAL = :CDFILIAL
    ";
    
    const VERIFY_ORDEM = "
        SELECT DSCLASSFINA, CDCLASSFINA, :IDORDEMDRE AS IDORDEMDRE
        FROM CLASSFINANC
        WHERE NRORG = :NRORG
          AND IDORDEMDRE = :IDORDEMDRE
    ";
    
    const VERIFY_PARAM_GERAL = "
        SELECT COUNT(*) AS REGISTROS FROM PARAMDRE WHERE NRORG = :NRORG
    ";
    
    const INSERT_PARAM_GERAL = "
        INSERT INTO PARAMDRE
        (CDTIPORETIVENDA, CDTIPORETIFUNC, CDTIPORETIDESP, CLASSFINCOMPRA, CDCLASSFINADRE, CDAJUCTPAGDRE, CLASSFINDESPESAS, CDAJUDESPESAS, NRORG)
        VALUES
        (:CDTIPORETIVENDA, :CDTIPORETIFUNC, :CDTIPORETIDESP, :CLASSFINCOMPRA, :CDCLASSFINADRE, :CDAJUCTRECDRE, :CLASSFINDESPESAS, :CDAJUDESPESAS, :NRORG)
    ";
    
    const UPDATE_PARAM_GERAL = "
        UPDATE PARAMDRE
          SET CDTIPORETIVENDA  = :CDTIPORETIVENDA,
              CDTIPORETIFUNC   = :CDTIPORETIFUNC,
              CDTIPORETIDESP   = :CDTIPORETIDESP,
              CLASSFINCOMPRA   = :CLASSFINCOMPRA,
              CDCLASSFINADRE   = :CDCLASSFINADRE,
              CDAJUCTPAGDRE    = :CDAJUCTRECDRE,
              CLASSFINDESPESAS = :CLASSFINDESPESAS,
              CDAJUDESPESAS    = :CDAJUDESPESAS
        WHERE  NRORG = :NRORG
    ";
}