<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelVendAreaAtend {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function find($CDFILIAL, $CDLOJA, $TCDLOJA, $DATAINI, $DATAFIN, $MODALIDADE, $TMODALIDADE, $NRORG) {
        $params = array(
         	":CDFILIAL" => $CDFILIAL,
         	":CDLOJA" => $CDLOJA,
         	":TCDLOJA" => $TCDLOJA,
         	":DATAINI" => $DATAINI,
         	":DATAFIN" => $DATAFIN,
         	":MODALIDADE" => $MODALIDADE,
         	":TMODALIDADE" => $TMODALIDADE,
         	":NRORG" => $NRORG
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_AREA_ATEND, $params);
    }

    public function buildParamsFaturamento($conditions){
        $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
        if(!array_key_exists('CDLOJA', $conditions)) {
            $conditions['CDLOJA'] = '';
            $conditions['TCDLOJA'] = 'T';
        } else {
            $conditions['CDLOJA'] = implode('_', $conditions['CDLOJA']);
            $conditions['TCDLOJA'] = '';
        }
        if(array_key_exists('MODALIDADE', $conditions)) {
         $conditions['MODALIDADE'] = implode('_', $conditions['MODALIDADE']);
         $conditions['TMODALIDADE'] = '';
        } else {
         $conditions['TMODALIDADE'] = 'T';
         $conditions['MODALIDADE'] = '';
        }
        if(array_key_exists('DTENTRVENDA', $conditions)) {
            $conditions['DATAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DATAFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
        }
        return $conditions;
    }

    const GET_VENDA_AREA_ATEND = "
        SELECT SUM((I.QTPRODVEND *(I.VRUNITVEND + I.VRUNITVENDCL) - (I.VRDESITVEND) + (I.VRACRITVEND))) AS VRTOTVEND, SUM(I.VRACRITVEND) AS VRTAXA, FILOCAVE.IDSITUVENDA, FILOCAVE.NRSEQVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA,
               FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS CODFILIAL, FILOCAVE.CDFILIAL AS LABCDFILIAL, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.DTVENDA, FILOCAVE.NRORG, FILOCAVE.DTENTRVENDA, FILOCAVE.DSAREAATENDVEN,
               FILOCAVE.MODALIDADE, FILOCAVE.DSENDECONSVENDA, FILOCAVE.CUPOM, FILOCAVE.NMBAIRRO
          FROM ITEMVENDA I
          JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, V.DTVENDA,
                      FILOCA.NRORG, V.DTENTRVENDA, V.DSAREAATENDVEN,
                      NVL(OV.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                      V.DSENDECONSVENDA, NVL(V.NRCUPOMFIS, V.NRNOTAFISCALCE) AS CUPOM, B.NMBAIRRO
                 FROM VENDA V
                 JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                         FROM CAIXA C
                         JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                 FROM LOJA L
                                 JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                         FROM FILIAL F
                                        WHERE (INSTR(:CDFILIAL, F.CDFILIAL) > 0)
                                          AND F.NRORG =:NRORG ) FI
                                   ON L.CDFILIAL = FI.CDFILIAL
                                  AND L.NRORG = FI.NRORG
                                WHERE ((INSTR(:CDLOJA, FI.CDFILIAL ||L.CDLOJA) > 0) OR (:TCDLOJA  = 'T'))) FILO
                           ON C.CDFILIAL = FILO.CDFILIAL
                          AND C.CDLOJA = FILO.CDLOJA
                          AND C.NRORG = FILO.NRORG) FILOCA
                   ON V.CDCAIXA = FILOCA.CDCAIXA
                  AND V.CDLOJA = FILOCA.CDLOJA
                  AND V.CDFILIAL = FILOCA.CDFILIAL
                  AND V.NRORG = FILOCA.NRORG
                   LEFT JOIN ORIGEMVENDAFOS OV
                ON V.IDORIGEMVENDA = OV.IDORIGEMVENDA
                AND V.NRORG = OV.NRORG
            LEFT JOIN BAIRRO B
                   ON V.CDBAIRRO = B.CDBAIRRO
                  AND V.NRORG = B.NRORG
                WHERE V.IDSITUVENDA = 'O'
                  AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                AND ((INSTR(:MODALIDADE, OV.IDORIGEMVENDA) > 0) OR (:TMODALIDADE = 'T'))
                  AND V.DSAREAATENDVEN IS NOT NULL) FILOCAVE
            ON I.CDFILIAL = FILOCAVE.CDFILIAL
           AND I.CDCAIXA = FILOCAVE.CDCAIXA
           AND I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
           AND I.NRORG = FILOCAVE.NRORG
         GROUP BY FILOCAVE.IDSITUVENDA, FILOCAVE.NRSEQVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NMCAIXA, FILOCAVE.CDLOJA, FILOCAVE.NMLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.DTVENDA, FILOCAVE.NRORG,
               FILOCAVE.DTENTRVENDA, FILOCAVE.DSAREAATENDVEN, FILOCAVE.MODALIDADE, FILOCAVE.DSENDECONSVENDA, FILOCAVE.CUPOM, FILOCAVE.NMBAIRRO
    ";
}